##// END OF EJS Templates
a
Unknown -
r547:47abd715d52a
parent child
Show More
@@ -1,289 +1,289
1 1 #
2 2 # Setup RPi2/3 config and cmdline
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 if [ -n "$RPI_FIRMWARE_DIR" ] && [ -d "$RPI_FIRMWARE_DIR" ] ; then
9 9 # Install boot binaries from local directory
10 10 cp "${RPI_FIRMWARE_DIR}"/boot/bootcode.bin "${BOOT_DIR}"/bootcode.bin
11 11 cp "${RPI_FIRMWARE_DIR}"/boot/fixup.dat "${BOOT_DIR}"/fixup.dat
12 12 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_cd.dat "${BOOT_DIR}"/fixup_cd.dat
13 13 cp "${RPI_FIRMWARE_DIR}"/boot/fixup_x.dat "${BOOT_DIR}"/fixup_x.dat
14 14 cp "${RPI_FIRMWARE_DIR}"/boot/start.elf "${BOOT_DIR}"/start.elf
15 15 cp "${RPI_FIRMWARE_DIR}"/boot/start_cd.elf "${BOOT_DIR}"/start_cd.elf
16 16 cp "${RPI_FIRMWARE_DIR}"/boot/start_x.elf "${BOOT_DIR}"/start_x.elf
17 17 else
18 18 # Create temporary directory for boot binaries
19 19 temp_dir=$(as_nobody mktemp -d)
20 20
21 21 # Install latest boot binaries from raspberry/firmware github
22 22 as_nobody wget -q -O "${temp_dir}/bootcode.bin" "${FIRMWARE_URL}/bootcode.bin"
23 23 as_nobody wget -q -O "${temp_dir}/fixup.dat" "${FIRMWARE_URL}/fixup.dat"
24 24 as_nobody wget -q -O "${temp_dir}/fixup_cd.dat" "${FIRMWARE_URL}/fixup_cd.dat"
25 25 as_nobody wget -q -O "${temp_dir}/fixup_x.dat" "${FIRMWARE_URL}/fixup_x.dat"
26 26 as_nobody wget -q -O "${temp_dir}/start.elf" "${FIRMWARE_URL}/start.elf"
27 27 as_nobody wget -q -O "${temp_dir}/start_cd.elf" "${FIRMWARE_URL}/start_cd.elf"
28 28 as_nobody wget -q -O "${temp_dir}/start_x.elf" "${FIRMWARE_URL}/start_x.elf"
29 29
30 30 # Move downloaded boot binaries
31 31 mv "${temp_dir}/"* "${BOOT_DIR}/"
32 32
33 33 # Remove temporary directory for boot binaries
34 34 rm -fr "${temp_dir}"
35 35
36 36 # Set permissions of the boot binaries
37 37 chown -R root:root "${BOOT_DIR}"
38 38 chmod -R 600 "${BOOT_DIR}"
39 39 fi
40 40
41 41 if [ "$ENABLE_KEYGEN" = true ] ; then
42 42
43 43 # go to chroot/boot/
44 44 cd "${BOOT_DIR}/" || exit
45 45
46 46 # Make a copy of start.elf
47 47 cp start.elf start.elf_backup
48 48
49 49 # Remove codec licence checks - thx go to https://github.com/nucular/raspi-keygen - if ENABLE_VIDEOCORE is true, you can check codec status https://elinux.org/RPI_vcgencmd_usage
50 50 perl -pne 's/\x47\xE9362H\x3C\x18/\x47\xE9362H\x3C\x1F/g' < start.elf_backup > start.elf
51 51
52 52 # Back to base dir
53 53 cd "${WORKDIR}" || exit
54 54 fi
55 55
56 56 # Setup firmware boot cmdline
57 57 if [ "$ENABLE_USBBOOT" = true ] ; then
58 58 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline console=tty1 rootwait init=/bin/systemd"
59 59 else
60 60 if [ "$ENABLE_SPLITFS" = true ] ; then
61 61 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/sda1 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline console=tty1 rootwait init=/bin/systemd"
62 62 else
63 63 CMDLINE="dwc_otg.lpm_enable=0 root=/dev/mmcblk0p2 rootfstype=ext4 rootflags=commit=100,data=writeback elevator=deadline console=tty1 rootwait init=/bin/systemd"
64 64 fi
65 65 fi
66 66
67 67 # Add encrypted root partition to cmdline.txt
68 68 if [ "$ENABLE_CRYPTFS" = true ] ; then
69 69 if [ "$ENABLE_SPLITFS" = true ] ; then
70 70 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda1/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda1:${CRYPTFS_MAPPING}/")
71 71 else
72 72 if [ "$ENABLE_USBBOOT" = true ] ; then
73 73 CMDLINE=$(echo "${CMDLINE}" | sed "s/sda2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/sda2:${CRYPTFS_MAPPING}/")
74 74 else
75 75 CMDLINE=$(echo "${CMDLINE}" | sed "s/mmcblk0p2/mapper\/${CRYPTFS_MAPPING} cryptdevice=\/dev\/mmcblk0p2:${CRYPTFS_MAPPING}/")
76 76 fi
77 77 fi
78 78 fi
79 79
80 80 # Enable Kernel messages on standard output
81 81 if [ "$ENABLE_PRINTK" = true ] ; then
82 82 install_readonly files/sysctl.d/83-rpi-printk.conf "${ETC_DIR}/sysctl.d/83-rpi-printk.conf"
83 83 fi
84 84
85 85 # Enable Kernel messages on standard output
86 86 if [ "$KERNEL_SECURITY" = true ] ; then
87 87 install_readonly files/sysctl.d/84-rpi-ASLR.conf "${ETC_DIR}/sysctl.d/84-rpi-ASLR.conf"
88 88 fi
89 89
90 90 # Install udev rule for serial alias - serial0 = console serial1=bluetooth
91 91 install_readonly files/etc/99-com.rules "${LIB_DIR}/udev/rules.d/99-com.rules"
92 92
93 93 # Remove IPv6 networking support
94 94 if [ "$ENABLE_IPV6" = false ] ; then
95 95 CMDLINE="${CMDLINE} ipv6.disable=1"
96 96 fi
97 97
98 98 # Automatically assign predictable network interface names
99 99 if [ "$ENABLE_IFNAMES" = false ] ; then
100 100 CMDLINE="${CMDLINE} net.ifnames=0"
101 101 else
102 102 CMDLINE="${CMDLINE} net.ifnames=1"
103 103 fi
104 104
105 105 # Install firmware config
106 106 install_readonly files/boot/config.txt "${BOOT_DIR}/config.txt"
107 107
108 108 # Locks CPU frequency at maximum
109 109 if [ "$ENABLE_TURBO" = true ] ; then
110 110 echo "force_turbo=1" >> "${BOOT_DIR}/config.txt"
111 111 # helps to avoid sdcard corruption when force_turbo is enabled.
112 112 echo "boot_delay=1" >> "${BOOT_DIR}/config.txt"
113 113 fi
114 114
115 115 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
116 116
117 117 # Bluetooth enabled
118 118 if [ "$ENABLE_BLUETOOTH" = true ] ; then
119 119 # Create temporary directory for Bluetooth sources
120 120 temp_dir=$(as_nobody mktemp -d)
121 121
122 122 # Fetch Bluetooth sources
123 123 as_nobody git -C "${temp_dir}" clone "${BLUETOOTH_URL}"
124 124
125 125 # Copy downloaded sources
126 126 mv "${temp_dir}/pi-bluetooth" "${R}/tmp/"
127 127
128 128 # Bluetooth firmware from arch aur https://aur.archlinux.org/packages/pi-bluetooth/
129 129 as_nobody wget -q -O "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" https://aur.archlinux.org/cgit/aur.git/plain/LICENCE.broadcom_bcm43xx?h=pi-bluetooth
130 130 as_nobody wget -q -O "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" https://aur.archlinux.org/cgit/aur.git/plain/BCM43430A1.hcd?h=pi-bluetooth
131 131
132 132 # Set permissions
133 133 chown -R root:root "${R}/tmp/pi-bluetooth"
134 134
135 135 # Install tools
136 136 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/btuart" "${R}/usr/bin/btuart"
137 137 install_readonly "${R}/tmp/pi-bluetooth/usr/bin/bthelper" "${R}/usr/bin/bthelper"
138 138
139 139 # make scripts executable
140 140 chmod +x "${R}/usr/bin/bthelper"
141 141 chmod +x "${R}/usr/bin/btuart"
142 142
143 143 # Install bluetooth udev rule
144 144 install_readonly "${R}/tmp/pi-bluetooth/lib/udev/rules.d/90-pi-bluetooth.rules" "${LIB_DIR}/udev/rules.d/90-pi-bluetooth.rules"
145 145
146 146 # Install Firmware Flash file and apropiate licence
147 147 mkdir -p "$BLUETOOTH_FIRMWARE_DIR"
148 148 install_readonly "${R}/tmp/pi-bluetooth/LICENCE.broadcom_bcm43xx" "${BLUETOOTH_FIRMWARE_DIR}/LICENCE.broadcom_bcm43xx"
149 149 install_readonly "${R}/tmp/pi-bluetooth/BCM43430A1.hcd" "${BLUETOOTH_FIRMWARE_DIR}/LICENCE.broadcom_bcm43xx"
150 150 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.bthelper@.service" "${ETC_DIR}/systemd/system/pi-bluetooth.bthelper@.service"
151 151 install_readonly "${R}/tmp/pi-bluetooth/debian/pi-bluetooth.hciuart.service" "${ETC_DIR}/systemd/system/pi-bluetooth.hciuart.service"
152 152
153 153 # Remove temporary directories
154 154 rm -fr "${temp_dir}"
155 155 rm -fr "${R}"/tmp/pi-bluetooth
156 156
157 157 # Switch Pi3 Bluetooth function to use the mini-UART (ttyS0) and restore UART0/ttyAMA0 over GPIOs 14 & 15. Slow Bluetooth and slow cpu. Use /dev/ttyS0 instead of /dev/ttyAMA0
158 158 if [ "$ENABLE_MINIUART_OVERLAY" = true ] ; then
159 159
160 160 # set overlay to swap ttyAMA0 and ttyS0
161 161 echo "dtoverlay=pi3-miniuart-bt" >> "${BOOT_DIR}/config.txt"
162 162
163 163 # if force_turbo didn't lock cpu at high speed, lock it at low speed (XOR logic) or miniuart will be broken
164 164 if [ "$ENABLE_TURBO" = false ] ; then
165 165 echo "core_freq=250" >> "${BOOT_DIR}/config.txt"
166 166 fi
167 167 fi
168 168
169 169 # Activate services
170 170 chroot_exec systemctl enable pi-bluetooth.hciuart.service
171 171
172 172 else # if ENABLE_BLUETOOTH = false
173 173 # set overlay to disable bluetooth
174 174 echo "dtoverlay=pi3-disable-bt" >> "${BOOT_DIR}/config.txt"
175 175 fi # ENABLE_BLUETOOTH end
176 176 fi
177 177
178 178 # may need sudo systemctl disable hciuart
179 179 if [ "$ENABLE_CONSOLE" = true ] ; then
180 180 echo "enable_uart=1" >> "${BOOT_DIR}/config.txt"
181 181 # add string to cmdline
182 182 CMDLINE="${CMDLINE} console=serial0,115200"
183 183
184 184 # Enable serial console systemd style
185 chroot_exec systemctl enable serial-getty\@serial0.service
185 chroot_exec systemctl enable serial-getty@serial0.service
186 186 else
187 187 echo "enable_uart=0" >> "${BOOT_DIR}/config.txt"
188 188 fi
189 189
190 190 if [ "$ENABLE_SYSTEMDSWAP" = true ] ; then
191 191 # Create temporary directory for systemd-swap sources
192 192 temp_dir=$(as_nobody mktemp -d)
193 193
194 194 # Fetch systemd-swap sources
195 195 as_nobody git -C "${temp_dir}" clone "${SYSTEMDSWAP_URL}"
196 196
197 197 # Copy downloaded systemd-swap sources
198 198 mv "${temp_dir}/systemd-swap" "${R}/tmp/"
199 199
200 200 # Change into downloaded src dir
201 201 cd "${R}/tmp/systemd-swap" || exit
202 202
203 203 # Build package
204 204 bash ./package.sh debian
205 205
206 206 # Change back into script root dir
207 207 cd "${WORKDIR}" || exit
208 208
209 209 # Set permissions of the systemd-swap sources
210 210 chown -R root:root "${R}/tmp/systemd-swap"
211 211
212 212 # Install package - IMPROVE AND MAKE IT POSSIBLE WITHOUT VERSION NR.
213 213 chroot_exec dpkg -i /tmp/systemd-swap/systemd-swap_4.0.1_any.deb
214 214
215 215 # Enable service
216 216 chroot_exec systemctl enable systemd-swap
217 217
218 218 # Remove temporary directory for systemd-swap sources
219 219 rm -fr "${temp_dir}"
220 220 else
221 221 # Enable ZSWAP in cmdline if systemd-swap is not used
222 222 if [ "$KERNEL_ZSWAP" = true ] ; then
223 223 CMDLINE="${CMDLINE} zswap.enabled=1 zswap.max_pool_percent=25 zswap.compressor=lz4"
224 224 fi
225 225 fi
226 226 if [ "$KERNEL_SECURITY" = true ] ; then
227 227 CMDLINE="${CMDLINE} apparmor=1 security=apparmor"
228 228 fi
229 229
230 230 # Install firmware boot cmdline
231 231 echo "${CMDLINE}" > "${BOOT_DIR}/cmdline.txt"
232 232
233 233 # Setup minimal GPU memory allocation size: 16MB (no X)
234 234 if [ "$ENABLE_MINGPU" = true ] ; then
235 235 echo "gpu_mem=16" >> "${BOOT_DIR}/config.txt"
236 236 fi
237 237
238 238 # Setup boot with initramfs
239 239 if [ "$ENABLE_INITRAMFS" = true ] ; then
240 240 echo "initramfs initramfs-${KERNEL_VERSION} followkernel" >> "${BOOT_DIR}/config.txt"
241 241 fi
242 242
243 243 # Create firmware configuration and cmdline symlinks
244 244 ln -sf firmware/config.txt "${R}/boot/config.txt"
245 245 ln -sf firmware/cmdline.txt "${R}/boot/cmdline.txt"
246 246
247 247 # Install and setup kernel modules to load at boot
248 248 mkdir -p "${LIB_DIR}/modules-load.d/"
249 249 install_readonly files/modules/rpi2.conf "${LIB_DIR}/modules-load.d/rpi2.conf"
250 250
251 251 # Load hardware random module at boot
252 252 if [ "$ENABLE_HWRANDOM" = true ] && [ "$BUILD_KERNEL" = false ] ; then
253 253 sed -i "s/^# bcm2708_rng/bcm2708_rng/" "${LIB_DIR}/modules-load.d/rpi2.conf"
254 254 fi
255 255
256 256 # Load sound module at boot
257 257 if [ "$ENABLE_SOUND" = true ] ; then
258 258 sed -i "s/^# snd_bcm2835/snd_bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
259 259 else
260 260 echo "dtparam=audio=off" >> "${BOOT_DIR}/config.txt"
261 261 fi
262 262
263 263 # Enable I2C interface
264 264 if [ "$ENABLE_I2C" = true ] ; then
265 265 echo "dtparam=i2c_arm=on" >> "${BOOT_DIR}/config.txt"
266 266 sed -i "s/^# i2c-bcm2708/i2c-bcm2708/" "${LIB_DIR}/modules-load.d/rpi2.conf"
267 267 sed -i "s/^# i2c-dev/i2c-dev/" "${LIB_DIR}/modules-load.d/rpi2.conf"
268 268 fi
269 269
270 270 # Enable SPI interface
271 271 if [ "$ENABLE_SPI" = true ] ; then
272 272 echo "dtparam=spi=on" >> "${BOOT_DIR}/config.txt"
273 273 echo "spi-bcm2708" >> "${LIB_DIR}/modules-load.d/rpi2.conf"
274 274 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ]; then
275 275 sed -i "s/spi-bcm2708/spi-bcm2835/" "${LIB_DIR}/modules-load.d/rpi2.conf"
276 276 fi
277 277 fi
278 278
279 279 # Disable RPi2/3 under-voltage warnings
280 280 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
281 281 echo "avoid_warnings=${DISABLE_UNDERVOLT_WARNINGS}" >> "${BOOT_DIR}/config.txt"
282 282 fi
283 283
284 284 # Install kernel modules blacklist
285 285 mkdir -p "${ETC_DIR}/modprobe.d/"
286 286 install_readonly files/modules/raspi-blacklist.conf "${ETC_DIR}/modprobe.d/raspi-blacklist.conf"
287 287
288 288 # Install sysctl.d configuration files
289 289 install_readonly files/sysctl.d/81-rpi-vm.conf "${ETC_DIR}/sysctl.d/81-rpi-vm.conf"
@@ -1,884 +1,884
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 # Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62 62
63 63
64 64 # Kernel deb packages for 32bit kernel
65 65 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
66 66 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
67 67 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
68 68 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
69 69 # Default precompiled 64bit kernel
70 70 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
71 71 # Generic
72 72 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
73 73 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
74 74 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
75 75
76 76 # Build directories
77 77 WORKDIR=$(pwd)
78 78 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
79 79 BUILDDIR="${BASEDIR}/build"
80 80
81 81 # Chroot directories
82 82 R="${BUILDDIR}/chroot"
83 83 ETC_DIR="${R}/etc"
84 84 LIB_DIR="${R}/lib"
85 85 BOOT_DIR="${R}/boot/firmware"
86 86 KERNEL_DIR="${R}/usr/src/linux"
87 87 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
88 88 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
89 89
90 90 # Firmware directory: Blank if download from github
91 91 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
92 92
93 93 # General settings
94 94 SET_ARCH=${SET_ARCH:=32}
95 95 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
96 96 PASSWORD=${PASSWORD:=raspberry}
97 97 USER_PASSWORD=${USER_PASSWORD:=raspberry}
98 98 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
99 99 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
100 100 EXPANDROOT=${EXPANDROOT:=true}
101 101
102 102 # Keyboard settings
103 103 XKB_MODEL=${XKB_MODEL:=""}
104 104 XKB_LAYOUT=${XKB_LAYOUT:=""}
105 105 XKB_VARIANT=${XKB_VARIANT:=""}
106 106 XKB_OPTIONS=${XKB_OPTIONS:=""}
107 107
108 108 # Network settings (DHCP)
109 109 ENABLE_DHCP=${ENABLE_DHCP:=true}
110 110
111 111 # Network settings (static)
112 112 NET_ADDRESS=${NET_ADDRESS:=""}
113 113 NET_GATEWAY=${NET_GATEWAY:=""}
114 114 NET_DNS_1=${NET_DNS_1:=""}
115 115 NET_DNS_2=${NET_DNS_2:=""}
116 116 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
117 117 NET_NTP_1=${NET_NTP_1:=""}
118 118 NET_NTP_2=${NET_NTP_2:=""}
119 119
120 120 # APT settings
121 121 APT_PROXY=${APT_PROXY:=""}
122 122 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
123 123
124 124 # Feature settings
125 125 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
126 126 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
127 127 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
128 128 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
129 129 ENABLE_I2C=${ENABLE_I2C:=false}
130 130 ENABLE_SPI=${ENABLE_SPI:=false}
131 131 ENABLE_IPV6=${ENABLE_IPV6:=true}
132 132 ENABLE_SSHD=${ENABLE_SSHD:=true}
133 133 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
134 134 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
135 135 ENABLE_SOUND=${ENABLE_SOUND:=true}
136 136 ENABLE_DBUS=${ENABLE_DBUS:=true}
137 137 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
138 138 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
139 139 ENABLE_XORG=${ENABLE_XORG:=false}
140 140 ENABLE_WM=${ENABLE_WM:=""}
141 141 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
142 142 ENABLE_USER=${ENABLE_USER:=true}
143 143 USER_NAME=${USER_NAME:="pi"}
144 144 ENABLE_ROOT=${ENABLE_ROOT:=false}
145 145 ENABLE_QEMU=${ENABLE_QEMU:=false}
146 146 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
147 147 ENABLE_KEYGEN=${ENABLE_KEYGEN:=true}
148 148
149 149 # SSH settings
150 150 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
151 151 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
152 152 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
153 153 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
154 154 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
155 155
156 156 # Advanced settings
157 157 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
158 158 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
159 159 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
160 160 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
161 161 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
162 162 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
163 163 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
164 164 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
165 165 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
166 166 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
167 167 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
168 168 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
169 169 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
170 170 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
171 171 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
172 172 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
173 173 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
174 174 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
175 175
176 176 # Kernel compilation settings
177 177 BUILD_KERNEL=${BUILD_KERNEL:=true}
178 178 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
179 179 KERNEL_THREADS=${KERNEL_THREADS:=1}
180 180 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
181 181 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
182 182 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
183 183 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
184 184 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
185 185 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
186 186 KERNEL_VIRT=${KERNEL_VIRT:=false}
187 187 KERNEL_BPF=${KERNEL_BPF:=false}
188 188 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=powersave}
189 189 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
190 190 KERNEL_NF=${KERNEL_NF:=false}
191 191
192 192 # Kernel compilation from source directory settings
193 193 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
194 194 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
195 195 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
196 196 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
197 197
198 198 # Reduce disk usage settings
199 199 REDUCE_APT=${REDUCE_APT:=true}
200 200 REDUCE_DOC=${REDUCE_DOC:=true}
201 201 REDUCE_MAN=${REDUCE_MAN:=true}
202 202 REDUCE_VIM=${REDUCE_VIM:=false}
203 203 REDUCE_BASH=${REDUCE_BASH:=false}
204 204 REDUCE_HWDB=${REDUCE_HWDB:=true}
205 205 REDUCE_SSHD=${REDUCE_SSHD:=true}
206 206 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
207 207
208 208 # Encrypted filesystem settings
209 209 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
210 210 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
211 211 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
212 212 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
213 213 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
214 214 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
215 215 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
216 216 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
217 217 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
218 218
219 219 # Chroot scripts directory
220 220 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
221 221
222 222 # Packages required in the chroot build environment
223 223 APT_INCLUDES=${APT_INCLUDES:=""}
224 224 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
225 225
226 226 # Packages to exclude from chroot build environment
227 227 APT_EXCLUDES=${APT_EXCLUDES:=""}
228 228
229 229 # Packages required for bootstrapping
230 230 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
231 231 MISSING_PACKAGES=""
232 232
233 233 # Packages installed for c/c++ build environment in chroot (keep empty)
234 234 COMPILER_PACKAGES=""
235 235
236 236 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
237 237 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
238 238 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
239 239 APT_PROXY=http://127.0.0.1:3142/
240 240 fi
241 241
242 242 # netselect-apt does not know buster yet
243 243 if [ "$RELEASE" = "buster" ] ; then
244 244 RLS=testing
245 245 else
246 246 RLS="$RELEASE"
247 247 fi
248 248
249 249 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
250 250 rm "$(pwd)/files/apt/sources.list"
251 251 fi
252 252
253 253 if [ "$ENABLE_NONFREE" = true ] ; then
254 254 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
255 255 else
256 256 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
257 257 fi
258 258
259 259 # sed and cut the result string so we can use it as APT_SERVER
260 260 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
261 261
262 262 # make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
263 263 if [ -n "$SET_ARCH" ] ; then
264 264 # 64-bit configuration
265 265 if [ "$SET_ARCH" = 64 ] ; then
266 266 # General 64-bit depended settings
267 267 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
268 268 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
269 269 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
270 270
271 271 # Raspberry Pi model specific settings
272 272 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
273 273 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
274 274 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
275 275 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
276 276 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
277 277 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
278 278 else
279 279 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
280 280 exit 1
281 281 fi
282 282 fi
283 283
284 284 # 32-bit configuration
285 285 if [ "$SET_ARCH" = 32 ] ; then
286 286 # General 32-bit dependend settings
287 287 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
288 288 KERNEL_ARCH=${KERNEL_ARCH:=arm}
289 289 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
290 290
291 291 # Raspberry Pi model specific settings
292 292 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
293 293 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
294 294 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
295 295 RELEASE_ARCH=${RELEASE_ARCH:=armel}
296 296 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
297 297 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
298 298 fi
299 299
300 300 # Raspberry Pi model specific settings
301 301 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
302 302 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
303 303 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
304 304 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
305 305 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
306 306 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
307 307 fi
308 308 fi
309 309 # SET_ARCH not set
310 310 else
311 311 echo "error: Please set '32' or '64' as value for SET_ARCH"
312 312 exit 1
313 313 fi
314 314 # Device specific configuration and U-Boot configuration
315 315 case "$RPI_MODEL" in
316 316 0)
317 317 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
318 318 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
319 319 ;;
320 320 1)
321 321 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
322 322 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
323 323 ;;
324 324 1P)
325 325 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
326 326 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
327 327 ;;
328 328 2)
329 329 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
330 330 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
331 331 ;;
332 332 3)
333 333 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
334 334 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
335 335 ;;
336 336 3P)
337 337 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
338 338 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
339 339 ;;
340 340 *)
341 341 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
342 342 exit 1
343 343 ;;
344 344 esac
345 345
346 346 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
347 347 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
348 348 # Include bluetooth packages on supported boards
349 349 if [ "$ENABLE_BLUETOOTH" = true ] ; then
350 350 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
351 351 fi
352 352 if [ "$ENABLE_WIRELESS" = true ] ; then
353 353 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,firmware-brcm80211"
354 354 fi
355 355 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
356 356 # Check if the internal wireless interface is not supported by the RPi model
357 357 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
358 358 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
359 359 exit 1
360 360 fi
361 361 fi
362 362
363 363 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
364 364 echo "error: You have to compile kernel sources, if you want to enable nexmon"
365 365 exit 1
366 366 fi
367 367
368 368 # Prepare date string for default image file name
369 369 DATE="$(date +%Y-%m-%d)"
370 370 if [ -z "$KERNEL_BRANCH" ] ; then
371 371 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
372 372 else
373 373 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
374 374 fi
375 375
376 376 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
377 377 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
378 378 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
379 379 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
380 380 exit 1
381 381 fi
382 382 fi
383 383
384 384 set +x
385 385
386 386 # Add cmake to compile videocore sources
387 387 if [ "$ENABLE_KEYGEN" = true ] ; then
388 388 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} perl"
389 389 fi
390 390
391 391 # Add cmake to compile videocore sources
392 392 if [ "$ENABLE_VIDEOCORE" = true ] ; then
393 393 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
394 394 fi
395 395
396 396 # Add deps for nexmon
397 397 if [ "$ENABLE_NEXMON" = true ] ; then
398 398 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
399 399 fi
400 400
401 401 # Add libncurses5 to enable kernel menuconfig
402 402 if [ "$KERNEL_MENUCONFIG" = true ] ; then
403 403 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
404 404 fi
405 405
406 406 # Add ccache compiler cache for (faster) kernel cross (re)compilation
407 407 if [ "$KERNEL_CCACHE" = true ] ; then
408 408 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
409 409 fi
410 410
411 411 # Add cryptsetup package to enable filesystem encryption
412 412 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
413 413 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
414 414 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
415 415
416 416 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
417 417 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
418 418 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
419 419 fi
420 420
421 421 if [ -z "$CRYPTFS_PASSWORD" ] ; then
422 422 echo "error: no password defined (CRYPTFS_PASSWORD)!"
423 423 exit 1
424 424 fi
425 425 ENABLE_INITRAMFS=true
426 426 fi
427 427
428 428 # Add initramfs generation tools
429 429 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
430 430 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
431 431 fi
432 432
433 433 # Add device-tree-compiler required for building the U-Boot bootloader
434 434 if [ "$ENABLE_UBOOT" = true ] ; then
435 435 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
436 436 fi
437 437
438 438 if [ "$ENABLE_USBBOOT" = true ] ; then
439 if ["$RPI_MODEL" != 3 ] || ["$RPI_MODEL" != 3P ] ; then
439 if ! ["$RPI_MODEL" = 3 ] || ! ["$RPI_MODEL" = 3P ] ; then
440 440 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
441 441 exit 1
442 442 fi
443 443 fi
444 444
445 445 # Check if root SSH (v2) public key file exists
446 446 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
447 447 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
448 448 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
449 449 exit 1
450 450 fi
451 451 fi
452 452
453 453 # Check if $USER_NAME SSH (v2) public key file exists
454 454 if [ -n "$SSH_USER_PUB_KEY" ] ; then
455 455 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
456 456 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
457 457 exit 1
458 458 fi
459 459 fi
460 460
461 461 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
462 462 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
463 463 exit 1
464 464 fi
465 465
466 466 # Check if all required packages are installed on the build system
467 467 for package in $REQUIRED_PACKAGES ; do
468 468 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
469 469 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
470 470 fi
471 471 done
472 472
473 473 # If there are missing packages ask confirmation for install, or exit
474 474 if [ -n "$MISSING_PACKAGES" ] ; then
475 475 echo "the following packages needed by this script are not installed:"
476 476 echo "$MISSING_PACKAGES"
477 477
478 478 printf "\ndo you want to install the missing packages right now? [y/n] "
479 479 read -r confirm
480 480 [ "$confirm" != "y" ] && exit 1
481 481
482 482 # Make sure all missing required packages are installed
483 483 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
484 484 fi
485 485
486 486 # Check if ./bootstrap.d directory exists
487 487 if [ ! -d "./bootstrap.d/" ] ; then
488 488 echo "error: './bootstrap.d' required directory not found!"
489 489 exit 1
490 490 fi
491 491
492 492 # Check if ./files directory exists
493 493 if [ ! -d "./files/" ] ; then
494 494 echo "error: './files' required directory not found!"
495 495 exit 1
496 496 fi
497 497
498 498 # Check if specified KERNELSRC_DIR directory exists
499 499 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
500 500 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
501 501 exit 1
502 502 fi
503 503
504 504 # Check if specified UBOOTSRC_DIR directory exists
505 505 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
506 506 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
507 507 exit 1
508 508 fi
509 509
510 510 # Check if specified VIDEOCORESRC_DIR directory exists
511 511 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
512 512 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
513 513 exit 1
514 514 fi
515 515
516 516 # Check if specified FBTURBOSRC_DIR directory exists
517 517 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
518 518 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
519 519 exit 1
520 520 fi
521 521
522 522 # Check if specified NEXMONSRC_DIR directory exists
523 523 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
524 524 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
525 525 exit 1
526 526 fi
527 527
528 528 # Check if specified CHROOT_SCRIPTS directory exists
529 529 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
530 530 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
531 531 exit 1
532 532 fi
533 533
534 534 # Check if specified device mapping already exists (will be used by cryptsetup)
535 535 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
536 536 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
537 537 exit 1
538 538 fi
539 539
540 540 # Don't clobber an old build
541 541 if [ -e "$BUILDDIR" ] ; then
542 542 echo "error: directory ${BUILDDIR} already exists, not proceeding"
543 543 exit 1
544 544 fi
545 545
546 546 # Setup chroot directory
547 547 mkdir -p "${R}"
548 548
549 549 # Check if build directory has enough of free disk space >512MB
550 550 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
551 551 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
552 552 exit 1
553 553 fi
554 554
555 555 set -x
556 556
557 557 # Call "cleanup" function on various signals and errors
558 558 trap cleanup 0 1 2 3 6
559 559
560 560 # Add required packages for the minbase installation
561 561 if [ "$ENABLE_MINBASE" = true ] ; then
562 562 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
563 563 fi
564 564
565 565 # Add parted package, required to get partprobe utility
566 566 if [ "$EXPANDROOT" = true ] ; then
567 567 APT_INCLUDES="${APT_INCLUDES},parted"
568 568 fi
569 569
570 570 # Add dbus package, recommended if using systemd
571 571 if [ "$ENABLE_DBUS" = true ] ; then
572 572 APT_INCLUDES="${APT_INCLUDES},dbus"
573 573 fi
574 574
575 575 # Add iptables IPv4/IPv6 package
576 576 if [ "$ENABLE_IPTABLES" = true ] ; then
577 577 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
578 578 fi
579 579 # Add apparmor for KERNEL_SECURITY
580 580 if [ "$KERNEL_SECURITY" = true ] ; then
581 581 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
582 582 fi
583 583
584 584 # Add openssh server package
585 585 if [ "$ENABLE_SSHD" = true ] ; then
586 586 APT_INCLUDES="${APT_INCLUDES},openssh-server"
587 587 fi
588 588
589 589 # Add alsa-utils package
590 590 if [ "$ENABLE_SOUND" = true ] ; then
591 591 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
592 592 fi
593 593
594 594 # Add rng-tools package
595 595 if [ "$ENABLE_HWRANDOM" = true ] ; then
596 596 APT_INCLUDES="${APT_INCLUDES},rng-tools"
597 597 fi
598 598
599 599 # Add fbturbo video driver
600 600 if [ "$ENABLE_FBTURBO" = true ] ; then
601 601 # Enable xorg package dependencies
602 602 ENABLE_XORG=true
603 603 fi
604 604
605 605 # Add user defined window manager package
606 606 if [ -n "$ENABLE_WM" ] ; then
607 607 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
608 608
609 609 # Enable xorg package dependencies
610 610 ENABLE_XORG=true
611 611 fi
612 612
613 613 # Add xorg package
614 614 if [ "$ENABLE_XORG" = true ] ; then
615 615 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
616 616 fi
617 617
618 618 # Replace selected packages with smaller clones
619 619 if [ "$ENABLE_REDUCE" = true ] ; then
620 620 # Add levee package instead of vim-tiny
621 621 if [ "$REDUCE_VIM" = true ] ; then
622 622 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
623 623 fi
624 624
625 625 # Add dropbear package instead of openssh-server
626 626 if [ "$REDUCE_SSHD" = true ] ; then
627 627 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
628 628 fi
629 629 fi
630 630
631 631 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
632 632 if [ "$ENABLE_SYSVINIT" = false ] ; then
633 633 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
634 634 fi
635 635
636 636 # Configure kernel sources if no KERNELSRC_DIR
637 637 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
638 638 KERNELSRC_CONFIG=true
639 639 fi
640 640
641 641 # Configure reduced kernel
642 642 if [ "$KERNEL_REDUCE" = true ] ; then
643 643 KERNELSRC_CONFIG=false
644 644 fi
645 645
646 646 # Configure qemu compatible kernel
647 647 if [ "$ENABLE_QEMU" = true ] ; then
648 648 DTB_FILE=vexpress-v2p-ca15_a7.dtb
649 649 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
650 650 KERNEL_DEFCONFIG="vexpress_defconfig"
651 651 if [ "$KERNEL_MENUCONFIG" = false ] ; then
652 652 KERNEL_OLDDEFCONFIG=true
653 653 fi
654 654 fi
655 655
656 656 # Execute bootstrap scripts
657 657 for SCRIPT in bootstrap.d/*.sh; do
658 658 head -n 3 "$SCRIPT"
659 659 . "$SCRIPT"
660 660 done
661 661
662 662 ## Execute custom bootstrap scripts
663 663 if [ -d "custom.d" ] ; then
664 664 for SCRIPT in custom.d/*.sh; do
665 665 . "$SCRIPT"
666 666 done
667 667 fi
668 668
669 669 # Execute custom scripts inside the chroot
670 670 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
671 671 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
672 672 chroot_exec /bin/bash -x <<'EOF'
673 673 for SCRIPT in /chroot_scripts/* ; do
674 674 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
675 675 $SCRIPT
676 676 fi
677 677 done
678 678 EOF
679 679 rm -rf "${R}/chroot_scripts"
680 680 fi
681 681
682 682 # Remove c/c++ build environment from the chroot
683 683 chroot_remove_cc
684 684
685 685 # Generate required machine-id
686 686 MACHINE_ID=$(dbus-uuidgen)
687 687 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
688 688 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
689 689
690 690 # APT Cleanup
691 691 chroot_exec apt-get -y clean
692 692 chroot_exec apt-get -y autoclean
693 693 chroot_exec apt-get -y autoremove
694 694
695 695 # Unmount mounted filesystems
696 696 umount -l "${R}/proc"
697 697 umount -l "${R}/sys"
698 698
699 699 # Clean up directories
700 700 rm -rf "${R}/run/*"
701 701 rm -rf "${R}/tmp/*"
702 702
703 703 # Clean up files
704 704 rm -f "${ETC_DIR}/ssh/ssh_host_*"
705 705 rm -f "${ETC_DIR}/dropbear/dropbear_*"
706 706 rm -f "${ETC_DIR}/apt/sources.list.save"
707 707 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
708 708 rm -f "${ETC_DIR}/*-"
709 709 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
710 710 rm -f "${ETC_DIR}/resolv.conf"
711 711 rm -f "${R}/root/.bash_history"
712 712 rm -f "${R}/var/lib/urandom/random-seed"
713 713 rm -f "${R}/initrd.img"
714 714 rm -f "${R}/vmlinuz"
715 715 rm -f "${R}${QEMU_BINARY}"
716 716
717 717 if [ "$ENABLE_QEMU" = true ] ; then
718 718 # Setup QEMU directory
719 719 mkdir "${BASEDIR}/qemu"
720 720
721 721 # Copy kernel image to QEMU directory
722 722 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
723 723
724 724 # Copy kernel config to QEMU directory
725 725 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
726 726
727 727 # Copy kernel dtbs to QEMU directory
728 728 for dtb in "${BOOT_DIR}/"*.dtb ; do
729 729 if [ -f "${dtb}" ] ; then
730 730 install_readonly "${dtb}" "${BASEDIR}/qemu/"
731 731 fi
732 732 done
733 733
734 734 # Copy kernel overlays to QEMU directory
735 735 if [ -d "${BOOT_DIR}/overlays" ] ; then
736 736 # Setup overlays dtbs directory
737 737 mkdir "${BASEDIR}/qemu/overlays"
738 738
739 739 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
740 740 if [ -f "${dtb}" ] ; then
741 741 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
742 742 fi
743 743 done
744 744 fi
745 745
746 746 # Copy u-boot files to QEMU directory
747 747 if [ "$ENABLE_UBOOT" = true ] ; then
748 748 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
749 749 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
750 750 fi
751 751 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
752 752 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
753 753 fi
754 754 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
755 755 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
756 756 fi
757 757 fi
758 758
759 759 # Copy initramfs to QEMU directory
760 760 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
761 761 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
762 762 fi
763 763 fi
764 764
765 765 # Calculate size of the chroot directory in KB
766 766 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
767 767
768 768 # Calculate the amount of needed 512 Byte sectors
769 769 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
770 770 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
771 771 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
772 772
773 773 # The root partition is EXT4
774 774 # This means more space than the actual used space of the chroot is used.
775 775 # As overhead for journaling and reserved blocks 35% are added.
776 776 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
777 777
778 778 # Calculate required image size in 512 Byte sectors
779 779 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
780 780
781 781 # Prepare image file
782 782 if [ "$ENABLE_SPLITFS" = true ] ; then
783 783 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
784 784 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
785 785 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
786 786 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
787 787
788 788 # Write firmware/boot partition tables
789 789 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
790 790 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
791 791 EOM
792 792
793 793 # Write root partition table
794 794 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
795 795 ${TABLE_SECTORS},${ROOT_SECTORS},83
796 796 EOM
797 797
798 798 # Setup temporary loop devices
799 799 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
800 800 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
801 801 else # ENABLE_SPLITFS=false
802 802 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
803 803 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
804 804
805 805 # Write partition table
806 806 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
807 807 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
808 808 ${ROOT_OFFSET},${ROOT_SECTORS},83
809 809 EOM
810 810
811 811 # Setup temporary loop devices
812 812 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
813 813 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
814 814 fi
815 815
816 816 if [ "$ENABLE_CRYPTFS" = true ] ; then
817 817 # Create dummy ext4 fs
818 818 mkfs.ext4 "$ROOT_LOOP"
819 819
820 820 # Setup password keyfile
821 821 touch .password
822 822 chmod 600 .password
823 823 echo -n ${CRYPTFS_PASSWORD} > .password
824 824
825 825 # Initialize encrypted partition
826 826 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
827 827
828 828 # Open encrypted partition and setup mapping
829 829 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
830 830
831 831 # Secure delete password keyfile
832 832 shred -zu .password
833 833
834 834 # Update temporary loop device
835 835 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
836 836
837 837 # Wipe encrypted partition (encryption cipher is used for randomness)
838 838 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
839 839 fi
840 840
841 841 # Build filesystems
842 842 mkfs.vfat "$FRMW_LOOP"
843 843 mkfs.ext4 "$ROOT_LOOP"
844 844
845 845 # Mount the temporary loop devices
846 846 mkdir -p "$BUILDDIR/mount"
847 847 mount "$ROOT_LOOP" "$BUILDDIR/mount"
848 848
849 849 mkdir -p "$BUILDDIR/mount/boot/firmware"
850 850 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
851 851
852 852 # Copy all files from the chroot to the loop device mount point directory
853 853 rsync -a "${R}/" "$BUILDDIR/mount/"
854 854
855 855 # Unmount all temporary loop devices and mount points
856 856 cleanup
857 857
858 858 # Create block map file(s) of image(s)
859 859 if [ "$ENABLE_SPLITFS" = true ] ; then
860 860 # Create block map files for "bmaptool"
861 861 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
862 862 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
863 863
864 864 # Image was successfully created
865 865 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
866 866 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
867 867 else
868 868 # Create block map file for "bmaptool"
869 869 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
870 870
871 871 # Image was successfully created
872 872 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
873 873
874 874 # Create qemu qcow2 image
875 875 if [ "$ENABLE_QEMU" = true ] ; then
876 876 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
877 877 QEMU_SIZE=16G
878 878
879 879 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
880 880 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
881 881
882 882 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
883 883 fi
884 884 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant